//----------------------------------------------------------------------------

//   Technics RS-B965 -   

//----------------------------------------------------------------------------

#include "Main.h"
#include "Key.h"
#include "RC5.h"

//----------------------------- : -----------------------------------

#define KEY_HOLD  120    //  

//----------------------------- : ----------------------------------

static char Key;         // 
static char PKey;        // -
static int KeyTimer;     //  

//-------------------------  : -------------------------------

void Key_Release(void);  //  

//-------------------------- : ----------------------------------

void Key_Init(void)
{
  Key = CMD_NOP;
  PKey = CMD_NOP;
  KeyTimer = 0;
  Key_Release();
}

//-----------------------   : ----------------------------

void Key_Release(void)
{
  Pwm_Set(OUT1, MAX_PWM);
  Pwm_Set(OUT2, MAX_PWM);
  Port_KEY_Z;
}

//-------------------------  : --------------------------------

void Key_Exe(bool t, char c)
{
  if(t)
  {
    if(KeyTimer) KeyTimer--;
      else
      {
        Key_Release();
        if(PKey != CMD_NOP)
        {
          KeyTimer = ms2sys(KEY_HOLD);
          switch(PKey)
          {
          case RC5_FF:  Pwm_Set(OUT2, KEY_FF);  break;
          case RC5_REW: Pwm_Set(OUT2, KEY_REW); break;
          }
          PKey = CMD_NOP;
        }
        else
        {
          __sleep();
        }
      }
  }
  if(c != CMD_NOP)
  {
    if(PKey == CMD_NOP)
      KeyTimer = ms2sys(KEY_HOLD);
    if(c != Key)
    {
      Key = c;
      Key_Release();
      switch(Key & ~RC5_CTRL)
      {
      case RC5_STOP:    Pwm_Set(OUT2, KEY_STOP);    break;
      case RC5_FF:      Pwm_Set(OUT2, KEY_STOP);    PKey = RC5_FF;  break;
      case RC5_REW:     Pwm_Set(OUT2, KEY_STOP);    PKey = RC5_REW; break;
      case RC5_PLAY:    Pwm_Set(OUT2, KEY_PLAY);    break;
      case RC5_REC:     Pwm_Set(OUT2, KEY_REC);     break;
      case RC5_PAUSE:   Pwm_Set(OUT2, KEY_PAUSE);   break;
      case RC5_DBX:     Pwm_Set(OUT2, KEY_DBX);     break;
      case RC5_DOLBYC:  Pwm_Set(OUT2, KEY_DOLBYC);  break;
      case RC5_DOLBYB:  Pwm_Set(OUT2, KEY_DOLBYB);  break;
      case RC5_MPX:     Pwm_Set(OUT2, KEY_MPX);     break;
      case RC5_CRESET:  Pwm_Set(OUT1, KEY_CRESET);  break;
      case RC5_CMODE:   Pwm_Set(OUT1, KEY_CMODE);   break;
      case RC5_RANGE:   Pwm_Set(OUT1, KEY_RANGE);   break;
      case RC5_MREPEAT: Pwm_Set(OUT1, KEY_MREPEAT); break;
      case RC5_MSTOP:   Pwm_Set(OUT1, KEY_MSTOP);   break;
      case RC5_OPEN:    Pwm_Set(OUT1, KEY_OPEN);    break;
      case RC5_MONITOR: Pwm_Set(OUT1, KEY_MONITOR); break;
      case RC5_DIRECT:  Pwm_Set(OUT1, KEY_DIRECT);  break;
      case RC5_CAL:     Pwm_Set(OUT1, KEY_CAL);     break;
      case RC5_APRS:    Pwm_Set(OUT1, KEY_APRS);    break;
      case RC5_ARM:     Port_KEY_0;                 break;
      case RC5_MSFF:    Pwm_Set(OUT2, KEY_PLAY);    PKey = RC5_FF;  break;
      case RC5_MSREW:   Pwm_Set(OUT2, KEY_PLAY);    PKey = RC5_REW; break;
      }
    }
    //MCUCR |= (1 << SE);               //TODO sleep enable
  }
}

//----------------------------------------------------------------------------

