//----------------------------------------------------------------------------

//   Technics RS-B965 -   ,  

//----------------------------------------------------------------------------

#ifndef KeyH
#define KeyH

//----------------------------------------------------------------------------

#include "Pwm.h"

//----------------------------- : -----------------------------------

//    , :

#define R1  10.0
#define R2  0.82
#define R3  1.0
#define R4  1.2
#define R5  1.5
#define R6  1.8
#define R7  2.2
#define R8  3.3
#define R9  4.7
#define R10 6.8
#define R11 12.0

//     PWM:

#define R2CODE(x, y) ((char)(MAX_PWM * (y) / ((x) + (y)) + 0.5))

// PWM   :

// OUT1 (pin 6):

#define KEY_CRESET  R2CODE(R1, 0)
#define KEY_CMODE   R2CODE(R1, R2)
#define KEY_RANGE   R2CODE(R1, R2+R3)
#define KEY_MREPEAT R2CODE(R1, R2+R3+R4)
#define KEY_MSTOP   R2CODE(R1, R2+R3+R4+R5)
#define KEY_OPEN    R2CODE(R1, R2+R3+R4+R5+R6+R7)
#define KEY_MONITOR R2CODE(R1, R2+R3+R4+R5+R6+R7+R8)
#define KEY_DIRECT  R2CODE(R1, R2+R3+R4+R5+R6+R7+R8+R9)
#define KEY_CAL     R2CODE(R1, R2+R3+R4+R5+R6+R7+R8+R9+R10)
#define KEY_APRS    R2CODE(R1, R2+R3+R4+R5+R6+R7+R8+R9+R10+R11)

// OUT2 (pin 9):

#define KEY_STOP    R2CODE(R1, 0)
#define KEY_FF      R2CODE(R1, R2)
#define KEY_REW     R2CODE(R1, R2+R3)
#define KEY_PLAY    R2CODE(R1, R2+R3+R4)
#define KEY_REC     R2CODE(R1, R2+R3+R4+R5)
#define KEY_PAUSE   R2CODE(R1, R2+R3+R4+R5+R6)
#define KEY_DBX     R2CODE(R1, R2+R3+R4+R5+R6+R7)
#define KEY_DOLBYC  R2CODE(R1, R2+R3+R4+R5+R6+R7+R8)
#define KEY_DOLBYB  R2CODE(R1, R2+R3+R4+R5+R6+R7+R8+R9)
#define KEY_MPX     R2CODE(R1, R2+R3+R4+R5+R6+R7+R8+R9+R10)

// RC-5   :

#define RC5_STOP    0x01
#define RC5_FF      0x21
#define RC5_REW     0x19
#define RC5_PLAY    0x09
#define RC5_REC     0x20
#define RC5_PAUSE   0x11
#define RC5_DBX     0x3a
#define RC5_DOLBYC  0x12
#define RC5_DOLBYB  0x03
#define RC5_MPX     0x0a
#define RC5_CRESET  0x13
#define RC5_CMODE   0x1b
#define RC5_RANGE   0x02
#define RC5_MREPEAT 0x2b
#define RC5_MSTOP   0x33
#define RC5_OPEN    0x00
#define RC5_MONITOR 0x28
#define RC5_DIRECT  0x0b
#define RC5_CAL     0x23
#define RC5_APRS    0x3b
#define RC5_ARM     0x30
#define RC5_MSFF    0x31
#define RC5_MSREW   0x29
#define RC5_NO      0x08

//-------------------------  : -------------------------------

void Key_Init(void);          // 
void Key_Exe(bool t, char c); // 

//----------------------------------------------------------------------------

#endif
