//----------------------------------------------------------------------------

//Project:     Technics RS-B965 -  
//Compiler: IAR EWAVR 6.12
//Target:   ATtiny25
//Fuses:    FFDFD2

//----------------------------------------------------------------------------

#include "Main.h"
#include "RC5.h"
#include "Pwm.h"
#include "Key.h"

//----------------------------- : ----------------------------------

volatile bool fTick;               //   
static bool tick;                  //    
static char code;                  //  RC-5

//--------------------------  : ------------------------------

void main(void);                   // 
void Main_Ports_Init(void);        // 
void Main_Timer_Init(void);        //  
bool Main_GetTick(void);           //  
#pragma vector = ADC_vect
__interrupt void SysTimer(void);   //  

//----------------------------------------------------------------------------
//--------------------------  : -----------------------------
//----------------------------------------------------------------------------

void main(void)
{
  Main_Ports_Init();               // 
  Main_Timer_Init();               //  
  RC5_Init();                      //   RC-5
  Pwm_Init();                      //  PWM
  Key_Init();                      //   
  __enable_interrupt();            // 

  while(1)                         // 
  {
    tick = Main_GetTick();         //  
    code = RC5_GetCom();           // 
    Key_Exe(tick, code);           // 
  }
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

//-------------------------  : ----------------------------

void Main_Ports_Init(void)
{
  DDRB  = I_DDRB;
  PORTB = I_PORTB;
}

//------------------    ------------------------

void Main_Timer_Init(void)
{
  //      -
  //    .

  ADCSRA = (1 << ADEN)  | //ADC enable
           (1 << ADSC)  | //ADC stert conversion
           (1 << ADATE) | //ADC auto trigger enable (free running mode)
           (1 << ADIE)  | //ADC interrupt enable
           (1 << ADPS2) | //ADC prescaler CK/128
           (1 << ADPS1) |
           (1 << ADPS0);
  fTick = 1;              // 
}

//---------------------   : -------------------------

bool Main_GetTick(void)
{
  if(!fTick) return(0);            //   
  fTick = 0;                       // 
  return(1);                       //  
}

//-------------------   : -------------------------

#pragma vector = ADC_vect
__interrupt void SysTimer(void)
{
  fTick = 1;                       //  
}

//----------------------------------------------------------------------------
