//----------------------------------------------------------------------------

//   Technics RS-B965 -  ,  

//----------------------------------------------------------------------------

#ifndef MainH
#define MainH

//----------------------------------------------------------------------------

#include <iotiny25.h>
#include <intrinsics.h>
#include <stdbool.h>

//----------------------------- : -----------------------------------

#define	F_CLK 8.000  // , 
#define T_SYS (128 * 13 / F_CLK) // , 

//-------------------------  : ---------------------------------

//I - 
//O - 
//B -  

//L -   
//H -   
//X -    
//A -  

//-------------------------------  B: ------------------------------------

#define NC_PB0 (1 << PB0) //IL -  
#define PWM2   (1 << PB1) //OL -  PWM2
#define RC5    (1 << PB2) //IH -   RC-5
#define KEY    (1 << PB3) //OL -  KEY
#define PWM1   (1 << PB4) //OL -  PWM1

//:
#define I_DDRB  (PWM2 | PWM1)
//  (in)    (out):
#define I_PORTB (NC_PB0 | PWM2 | PWM1)
//    :
#define Port_KEY_0 (DDRB |= KEY)
#define Port_KEY_Z (DDRB &= ~KEY)
#define Pin_RC5      (PINB & RC5)

//-------------------------- : -------------------------------

#define LO(x)    ((char)((x) & 0xFF))
#define HI(x)    ((char)(((x) >> 8) & 0xFF))
#define BYTE1(x) (LO(x))
#define BYTE2(x) (HI(x))
#define BYTE3(x) ((char)(((unsigned long)(x) >> 16) & 0xFF))
#define BYTE4(x) ((char)(((unsigned long)(x) >> 24) & 0xFF))

#define WORD(b1,b0)        (((unsigned int)(b1) << 8) | (b0))
#define DWORD(b3,b2,b1,b0) (((unsigned long)WORD(b3,b2) << 16) | WORD(b1,b0))

#define ABS(x) (((x) < 0)? -(x) : (x))

#define Delay_us(x) __delay_cycles((unsigned int)((x) * F_CLK + 0.5))
#define ms2sys(x) ((unsigned int)(1E3 * (x) / T_SYS))
#define s2sys(x) ((unsigned long)(1E6 * (x) / T_SYS))

//----------------------------------------------------------------------------

#endif
